/* A card game where the player gets assigned spanks based on the deal of the cards. */

setInfos(4, "Hit or Stay", "A spanking card game", "marspank", "complete", 0xFFFFFF, "en", ["spanking", "game","femaletop"]);

//Configurable starting conditions
def startingValue = 25
def maximumHits = 5
def implementArray = ["Paddle","Bath Brush","Hairbrush","Wooden Spoon"]

def showGameImage = { //Randomly select an image
	def imageNumber = getRandom(5)+1
	setImage("hitorstay/sitting"+imageNumber+".jpg")
}


def suitArray = ["Hearts","Diamonds","Spades","Clubs"]
def faceArray = ["Ace","2","3","4","5","6","7","8","9","10","Jack","Queen","King"]
def faceValueArray = [15,2,3,4,5,6,7,8,9,10,11,12,13]
def implementUsed = [false,false,false,false]
def totalArray = [0,0,0,0]
def implementValue
def cardValue
def suit
def firstSuit
def dealt = new boolean[52]
def shuffle = {
	for(i in 0..51)
	{
		dealt[i] = false
	}
}
shuffle()

def respectTitle = "Miss"
if(loadBoolean("intro.likefemale"))
{
	respectTitle = "Miss"
}
/*else //Edited out because only female images
{
	respectTitle = "Sir"
}*/
def rulesDisplay = {
		show("Hit or Stay is a spanking card game played in rounds.")
	showButton("Sounds interesting so far "+respectTitle+".")
	show("You start each round with "+startingValue+" spanks earned."+
		"\nThen you draw your first card.")
	wait(15)
	show("If your card is red, the value of the card is subtracted from your total."
		+"\nBut if it is black, the value gets added."
		+"\n\nJacks are 11, Queens 12, Kings 13, and Aces 15")
	showButton("I follow you "+respectTitle+".")
	show("One more thing... \n\nIf your total ever hits or goes below 0, it will be reset to the starting value."
		+"\n\nSo be careful about that")
	showButton("Yes "+respectTitle+".")
	show("You will then be given the choice to hit or stay."
		+"\nIf you hit, you will draw another card and continue on. But you can only hit 5 times. After that, you must stay."
		+"\n\nIf you stay, you earn your total number of spanks with the chosen implement.")
	showButton("Implement?")
	show("Yes, the implement for the round depends on the first card you choose."
		+"\n\t"+suitArray[0]+":"+implementArray[0]
		+"\n\t"+suitArray[1]+":"+implementArray[1]
		+"\n\t"+suitArray[2]+":"+implementArray[2]
		+"\n\t"+suitArray[3]+":"+implementArray[3])
	showButton("I understand "+respectTitle+".")
	show("And now for the truly sinister part, how the rounds work.")
	wait(10)
	show("You will keep playing until you have earned spanks for all 4 implements."
		+"\n\n And the cards will be reshuffled after every round.")
	showButton("...gulp...")
	show("Also, all of the payouts will be at the end, so your spanking will be continuous.")
	showButton("Yes "+respectTitle+".")
}

def gameround = {
	//draw first card
	cardValue = getRandom(13)
	suit = getRandom(4)
	def cardNumber = suit*13+cardValue
	dealt[cardNumber] = true
	firstSuit = suit
	def hits = 0
	def roundTotal = startingValue

	if(suit < 2){ roundTotal = roundTotal - faceValueArray[cardValue]}
	else{ roundTotal = roundTotal + faceValueArray[cardValue] }
	def pickoption = getSelectedValue("You drew the "+faceArray[cardValue]+" of "+suitArray[suit]
			+"\n\nYour starting total is "+roundTotal
			+"\n\nAnd the implement you will be paying with is the "+implementArray[firstSuit]
			+"\n\nWhat would you like to do?",["Hit","Stay"])
	while(pickoption == 0 && hits < maximumHits)
	{
		while(dealt[cardNumber])
		{
			cardValue = getRandom(13)
			suit = getRandom(4)
			cardNumber = suit*13+cardValue
		}
		if(suit < 2){ roundTotal = roundTotal - faceValueArray[cardValue]}
		else{ roundTotal = roundTotal + faceValueArray[cardValue] }
		hits = hits+1

		if(roundTotal <= 0){ roundTotal = startingValue }
		
		if(hits < maximumHits)
		{			
			pickoption = getSelectedValue("You drew the "+faceArray[cardValue]+" of "+suitArray[suit]
					+"\n\nYour new total is "+roundTotal+"\n\nWhat would you like to do?",["Hit","Stay"])
		}
		else
		{
			show("You drew the "+faceArray[cardValue]+" of "+suitArray[suit]
					+"\n\nYour new total is "+roundTotal
					+"\n\nThat was your last opportunity to hit. Now you must stay.")
			wait(10)
		}
		dealt[cardNumber] = true
	}
	show("This round has earned you "+roundTotal+" smacks with the "+implementArray[firstSuit])
	totalArray[firstSuit] = totalArray[firstSuit]+roundTotal
	implementUsed[firstSuit] = true
	wait(15)
}

def spank = {
	message, spanks, time ->
	show(""+message+"\n\n. . ")
	wait(3)
	def x=0
	(1..spanks).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("swat.wav")
		wait(time)
	}
}
def imageSpeed = 20
def setImageFancy = { picture ->
	if (imageSpeed <= 0) imageSpeed = 0.1
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
	def width = image.getWidth()
	def height = image.getHeight()
	
	(1..10).each {
		def frameBuffer = new java.awt.image.BufferedImage( (int)((width*it)/10), (int)((height*it)/10),
 							  java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
		def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
	
		java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	
		graphics.drawImage(sprite, 0, 0, (int)((width*it)/10), (int)((height*it)/10), null)
	
		setImage(frameBuffer, false)
		wait(1/imageSpeed)
	}
}
def setImageOffFancy = { picture ->
	if (imageSpeed <= 0) imageSpeed = 0.1
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
	def width = image.getWidth()
	def height = image.getHeight()
	
	(1..10).each {
		def frameBuffer = new java.awt.image.BufferedImage( (int)(width/it), (int)(height/it),
 							  java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
		def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
	
		java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	
		graphics.drawImage(sprite, 0, 0, (int)(width/it), (int)(height/it), null)
	
		setImage(frameBuffer, false)
		wait(1/imageSpeed)
	}
	setImage(null)
}

//START OF SCRIPT
show("Time to play Hit or Stay")
setImage("hitorstay/intro.jpg")
wait(10)

if(getBoolean("Do you want to review the rules?","Yes","I know them"))
{
	rulesDisplay()
	while(getBoolean("Do you need to go back over the rules again?","Yes","I understand them"))
	{
		rulesDisplay()
	}
}
show("Let the first round begin")
wait(5)
gameround()
while(!implementUsed[0] || !implementUsed[1] || !implementUsed[2] || !implementUsed[3])
{
	show("Looks like you have to play another round. Have fun.")
	showGameImage()
	wait(10)
	shuffle()
	gameround()
}
show("Well well well, looks like my naughty spankee has finally finished.")
wait(10)
show("Are you ready to pay the piper?")
showButton("Yes "+respectTitle)
show("Bare your bottom")
showButton("Bottom bared "+respectTitle)
show("Now get yourself into a good spanking position.\n\nPerhaps down on all fours..")
setImageFancy("hitorstay/allfours.jpg")
wait(15)
setImageOffFancy("hitorstay/allfours.jpg")
show("Or you could simply be kneeling")
setImageFancy("hitorstay/kneeling1.jpg")
wait(15)
setImageOffFancy("hitorstay/kneeling1.jpg")
showGameImage()
show("Either way, get into a spanking position.")
showButton("Yes "+respectTitle)
for(i in 0..3)
{
	show("Grab my "+implementArray[i])
	showButton("I have it "+respectTitle)
	show("You have "+totalArray[i]+" swats coming to you.")
	showButton("Yes "+respectTitle)
	def messageArray = ["Alternate cheeks, HARD!","Alternate sit spots, HARD!","Alternate cheeks"]
	switch(getRandom(3))
	{
		case 0: spank(messageArray[0],totalArray[i],1);break
		case 1: spank(messageArray[1],totalArray[i],1);break
		case 2: spank(messageArray[2],totalArray[i],0.75);break
	}
	if(i<3)
	{
		def secMessageArray = ["Hope you are having as much as I am tanning your buttocks.\nEspecially since you have more implements to go.","Watching you spank yourself is so much fun.\nI can't wait for the next implement","I'm so glad you decided to play this game with me.\nGet ready for the next implement.","Hang in there, you still have more spanking to come.","I hope you aren't regretting your decision to play with me, seeing as your spanking hasn't finished yet."]
		show(secMessageArray[getRandom(5)])
		wait(10)
	}
}
show("Now wasn't that a fun game?"
	+"\nCome back soon so we can play it again.")
wait(10)



// This script, from http://ss.deviatenow.com, is protected by this licence : 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/
// (Author may change thoses lines)



/*
 * Resources
 * scripts/hitorstay.groovy
 * images/hitorstay/intro.jpg
 * images/hitorstay/sitting5.jpg
 * images/hitorstay/sitting4.jpg
 * images/hitorstay/sitting1.jpg
 * images/hitorstay/sitting2.jpg
 * images/hitorstay/sitting3.jpg
 * images/hitorstay/allfours.jpg
 * images/hitorstay/kneeling1.jpg
 */